﻿using Models.Game;

namespace Models.Interfaces;

public interface IRules
{
    //public bool NearCellIsValid(Position playerChoicePosition, SortedDictionary<Position, Cell> cells);

    //public bool IsCellEmpty(Cell playerChoice);

    //public bool IsCellValid(Position playerChoicePosition, List<Position, Cell> cells);

    //public bool IsRopePath(Cell playerChoice, HashSet<RopePath> ropePaths);

    //public bool IsAdjacent(Cell cell1, Cell cell2, List<Position, Cell> cells);

    //public int HowMany(Cell playerChoice, List<Position, Cell> cells);

    //public void SetValueAndPenalty(int valueChoice, Cell playerChoice, List<Position, Cell> cells);

    public bool IsCellAdjacent(Cell choosenCell, Cell targetCell);

    public bool NearCellIsValid(Cell choosenCell, List<Cell> cells);

    public bool IsZoneValidAndAddToZones(Cell chosenCell, Map map);

    public bool IsValueInZones(Cell chosenCell, List<List<Cell>> zones);

    public bool IsCellInZone(Cell chosenCell, List<List<Cell>> zones);

    public void AddToZone(Cell chosenCell, List<List<Cell>> zones);

    public void NewZoneIsCreated(Cell firstCell, Cell secondCell, Map map);

    public List<Cell> EveryAdjacentCells(Cell choosenCell, List<Cell> cells);

    public int? FinalCalculusOfZones(List<List<Cell>> zones);

    public bool IsInRopePaths(Cell adjacente, List<List<Cell>> ropePaths, int index);

    public bool AsValue(Cell choosenCell, List<List<Cell>> ropePaths, int index);

}